.\" $NetBSD: pckbd.4,v 1.18 2009/04/06 17:34:13 mkirby Exp $
.\"
.\" Copyright (c) 1999
.\" 	Matthias Drochner.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd May 21, 2008
.Dt PCKBD 4
.Os
.Sh NAME
.Nm pckbd
.Nd PC keyboard driver for wscons
.Sh SYNOPSIS
.Cd pckbc* at isa?
.Cd pckbd* at pckbc?
.Cd "wskbd* at pckbd? console ?"
.Cd options PCKBD_LAYOUT=XXX
.Sh DESCRIPTION
This driver supports PC/AT keyboards within the
.Xr wscons 4
console framework. It doesn't provide direct device
driver entry points but makes its functions available via
the internal
.Xr wskbd 4
interface.
.Pp
The
.Nm
driver supports a number of different key mappings which
can be chosen from with the kernel option
.Li PCKBD_LAYOUT
at compile time or with the utility
.Xr wsconsctl 8
(variable:
.Dq encoding )
at runtime.
Other mappings can be used if the whole keymap is replaced by means of
.Xr wsconsctl 8 .
The builtin mappings are at this time:
.Bl -column " KB_US|KB_COLEMAK" "wsconsctl" "language"
.It Sy "option" Ta Sy "wsconsctl" Ta Sy "language"
.It Li KB_US Ta us Ta English/US keyboard mapping (default)
.It Li KB_DE Ta de Ta German with
.Dq dead accents
.It Li KB_FR Ta fr Ta French
.It Li KB_DK Ta dk Ta Danish with
.Dq dead accents
.It Li KB_IT Ta it Ta Italian
.It Li KB_UK Ta uk Ta British
.It Li KB_JP Ta jp Ta Japanese
.It Li KB_SV Ta sv Ta Swedish with
.Dq dead accents
.It Li "KB_US|KB_DECLK" Ta \&us.declk Ta English/US mapping for Tn DEC
.It Ta Ta LK400-style keyboards with PC keyboard
.It Ta Ta interface (e.g., LK461)
.It Li "KB_US|KB_DVORAK" Ta us.dvorak Ta English/US keyboard with
.It Ta Ta Do Dvorak Dc layout
.It Li "KB_US|KB_COLEMAK" Ta us.colemak Ta English/US keyboard with
.It Ta Ta Do Colemak Dc layout
.It Li KB_NO Ta no Ta Norwegian with
.Dq dead accents
.It Li KB_PT Ta pt Ta Portuguese
.It Li KB_ES Ta es Ta Spanish
.It Li KB_CZ Ta cz Ta Czech (QWERTY)
.El
.Pp
The
.Li KB_DE ,
.Li KB_DK ,
.Li KB_NO
and
.Li KB_SV
mappings can be used in the
.Li KB_NODEAD (
.Dq .nodead )
variant.  This switches off the
.Dq dead accents .
.Pp
The
.Li KB_US ,
.Li KB_JP
and
.Li KB_US|KB_DVORAK
mappings can be modified
to swap the left CTRL and the CAPS LOCK keys by the
.Li KB_SWAPCTRLCAPS
variant bit or the
.Dq .swapctrlcaps
suffix.
.Pp
The
.Li KB_METAESC (
.Dq .metaesc )
option can be applied to any layout.  If set, keys pressed together
with the ALT modifier are prefixed by an ESC character.  (Standard
behaviour is to add 128 to the ASCII value.)
.Pp
Because PC keyboard hardware doesn't contain a beeper, requests for
.Dq keyboard beeps
cannot be handled directly. On alpha and i386 a helper device attached
to the
.Xr pcppi 4
driver allows the use of the standard ISA speaker for this purpose.
On acorn32,
.Xr vidcaudio 4
performs this function.
.Sh EXAMPLES
To set a German keyboard layout without
.Dq dead accents
and sending an ESC character before the key symbol if the ALT
key is pressed simultaneously, use
.Ic wsconsctl Fl w Ar encoding=de.nodead.metaesc .
To set it at kernel build time, add
.D1 Cd options PCKBD_LAYOUT="(KB_DE | KB_NODEAD | KB_METAESC)"
to the kernel configuration file.
.Sh SEE ALSO
.Xr isa 4 ,
.Xr pcppi 4 ,
.Xr wskbd 4 ,
.Xr wsconsctl 8
.Sh BUGS
The list of builtin mappings doesn't follow any logic.
It grew as people submitted what they needed.
